#!/usr/bin/env python

import sys, gtk, vte, subprocess
#Needs at least python-gtk2 and python-vte installed (a must have)

class Quickterm(gtk.Window):

#Toolbar2 functions

    def copy(self, widget):
        self.vte.copy_clipboard()
        self.vte.grab_focus()

    def paste(self, widget):
        self.vte.paste_clipboard()
        self.vte.grab_focus()
        
    def clear_terminal(self,widget):
        self.vte.feed_child("clear")       
        
    def clear_history(self,widget):
        self.vte.feed_child("history -c")

    def memory(self,widget):
        self.vte.feed_child("sh /usr/share/memory.sh")
    
    def sound(self,widget):
        self.vte.feed_child("sh /usr/share/sound.sh")
        
    def mount(self,widget):
        self.vte.feed_child("sh /usr/share/mount.sh ")
        
    def wlan(self,widget):
        self.vte.feed_child("sudo sh /usr/share/wlanset.sh")
     
    def net(self,widget):
        self.vte.feed_child("sudo sh /usr/share/netset.sh")
        
    def miimo(self,widget):
        self.vte.feed_child("sh /usr/share/starter.sh")
        
                
    def apt(self,widget):
        self.vte.feed_child("sudo sh /usr/share/apt.sh")

    def updates(self,widget):
        self.vte.feed_child("sudo sh /usr/share/updates.sh")        
                        
        
                                          
		
#About dialog function
    def about1 (self, widget):
        about1 = gtk.AboutDialog()
        about1.set_program_name("Quick Terminal ")
        about1.set_version("V.0.3-PostX")
        about1.set_copyright(" Copyright (c) 2016 JJ Posti <techtimejourney.net>")
        about1.set_comments("Quick terminal is a terminal emulator written with Python. The program comes with ABSOLUTELY NO WARRANTY; for details see: http://www.gnu.org/copyleft/gpl.html. This is free software, and you are welcome to redistribute it under GPL Version 2, June 1991.")
        about1.set_website("www.techtimejourney.net")
        about1.run()
        about1.destroy()
 
###########	
#Make the window
###########	
    def __init__(self):    
    # Create THE WINDOW
        self.window1 = gtk.Window(gtk.WINDOW_TOPLEVEL)        
        self.window1.set_title("Quick Terminal")
#Toolbars
        self.toolbar=gtk.Toolbar()
        self.toolbar2=gtk.Toolbar()

#Create menubar
        self.bar=gtk.MenuBar()
#################################
###MENUS
###############

###FILE MENU
    #Create menu items for File menu

        self.file_menu=gtk.Menu()
        self.filemenu=gtk.MenuItem("File")
        self.filemenu.set_submenu(self.file_menu)
 
#Buttons for File menu

#Close button for file menu

        self.away=gtk.MenuItem("Close")
        self.away.connect("activate", gtk.main_quit)

#About button for file menu

        self.about=gtk.MenuItem("About")
        self.about.connect("activate", self.about1)
        
#Appending things to File_menu        
        self.file_menu.append(self.about)
        self.file_menu.append(self.away)

#Appending things to Menubar
        self.bar.append(self.filemenu)
        	

#Toolbar2 buttons
        
        self.COPY_button=gtk.ToolButton(gtk.STOCK_COPY)
        self.COPY_button.set_label("Copy")
        self.COPY_button.connect("clicked", self.copy)               
        self.COPY_button.set_tooltip_text ("Copy")
        self.toolbar2.insert(self.COPY_button, -1)
        
        self.PASTE_button=gtk.ToolButton(gtk.STOCK_PASTE)
        self.PASTE_button.set_label("Paste")
        self.PASTE_button.connect("clicked", self.paste)
        self.PASTE_button.set_tooltip_text ("Paste")               
        self.toolbar2.insert(self.PASTE_button, -1)
             
        self.CLEAR_button=gtk.ToolButton(gtk.STOCK_CLOSE)
        self.CLEAR_button.set_label("Clear Terminal")
        self.CLEAR_button.connect("clicked", self.clear_terminal)
        self.CLEAR_button.set_tooltip_text ("Clear Terminal") 
        self.toolbar2.insert(self.CLEAR_button, -1)  
        
        self.CLEAR2_button=gtk.ToolButton(gtk.STOCK_CLEAR)
        self.CLEAR2_button.set_label("Clear History")
        self.CLEAR2_button.connect("clicked", self.clear_history)
        self.CLEAR2_button.set_tooltip_text ("Clear History")       
        self.toolbar2.insert(self.CLEAR2_button, -1)               

        self.SOUND_button=gtk.ToolButton(gtk.STOCK_PROPERTIES)
        self.SOUND_button.set_label("Alsa Sound Selector")
        self.SOUND_button.connect("clicked", self.sound)
        self.SOUND_button.set_tooltip_text ("Alsa Sound Selector")       
        self.toolbar2.insert(self.SOUND_button, -1) 

        self.MEMORY_button=gtk.ToolButton(gtk.STOCK_INFO)
        self.MEMORY_button.set_label("Memory Status")
        self.MEMORY_button.connect("clicked", self.memory)
        self.MEMORY_button.set_tooltip_text ("Memory Status")       
        self.toolbar2.insert(self.MEMORY_button, -1) 
        
        self.MOUNT_button=gtk.ToolButton(gtk.STOCK_HARDDISK)
        self.MOUNT_button.set_label("Simple Mount")
        self.MOUNT_button.connect("clicked", self.mount)
        self.MOUNT_button.set_tooltip_text ("Simple Mount")       
        self.toolbar2.insert(self.MOUNT_button, -1)
        
        self.WLAN_button=gtk.ToolButton(gtk.STOCK_PROPERTIES)
        self.WLAN_button.set_label("Wlan setup")
        self.WLAN_button.connect("clicked", self.wlan)
        self.WLAN_button.set_tooltip_text ("Wlan Setup")       
        self.toolbar2.insert(self.WLAN_button, -1) 
        
        self.NET_button=gtk.ToolButton(gtk.STOCK_CONNECT)
        self.NET_button.set_label("Network setup")
        self.NET_button.connect("clicked", self.net)
        self.NET_button.set_tooltip_text ("Network Setup")       
        self.toolbar2.insert(self.NET_button, -1)
        
        self.MIIMO_button=gtk.ToolButton(gtk.STOCK_OPEN)
        self.MIIMO_button.set_label("Miimo Tool")
        self.MIIMO_button.connect("clicked", self.miimo)
        self.MIIMO_button.set_tooltip_text ("Miimo Decompress/Compress")       
        self.toolbar2.insert(self.MIIMO_button, -1)                        

        self.APT_button=gtk.ToolButton(gtk.STOCK_GO_DOWN)
        self.APT_button.set_label("Apt Fetcher")
        self.APT_button.connect("clicked", self.apt)
        self.APT_button.set_tooltip_text ("Apt Fetcher")       
        self.toolbar2.insert(self.APT_button, -1)    

        self.UPDATES_button=gtk.ToolButton(gtk.STOCK_REFRESH)
        self.UPDATES_button.set_label("Updates")
        self.UPDATES_button.connect("clicked", self.updates)
        self.UPDATES_button.set_tooltip_text ("Chech Updates")       
        self.toolbar2.insert(self.UPDATES_button, -1) 


#Terminal
        self.vte = vte.Terminal()
        self.vte.connect ("child-exited", lambda term: gtk.main_quit())

#fork_command
        self.vte.fork_command()

#Scrolled window
        self.scroll=gtk.ScrolledWindow()
        self.scroll.set_policy(gtk.POLICY_NEVER,
                               gtk.POLICY_AUTOMATIC)
        self.scroll.set_usize(650, 450)
        self.scroll.add(self.vte)


#Vertical box/buttons container
        self.vbox=gtk.VBox(False)

        self.vbox.pack_start(self.bar, False, False, 1)
        self.vbox.pack_start(self.toolbar2, False, False, 2)
        self.vbox.pack_start(self.scroll, True, True, 2)

#Show everything		
        self.window1.add(self.vbox)
        self.window1.show_all()
         
#Making window resizable and enabling the close window connector        
        self.window1.set_resizable(True)
        self.window1.connect('delete-event', lambda window, event: gtk.main_quit())

def main():
    gtk.main()
    return 0

if __name__ == "__main__":
    Quickterm()
    main()




